<template>
  <div class="app-container">
    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="45%" v-dialogDrag append-to-body>
      <el-form ref="formRef" :model="formData" :rules="formRules" v-loading="formLoading" label-width="100px">
                    <el-form-item label="厂商名称" prop="manufacturerName">
                      <el-input v-model="formData.manufacturerName" placeholder="请输入厂商名称" />
                    </el-form-item>
                    <el-form-item label="服务名称" prop="serviceName">
                      <el-input v-model="formData.serviceName" placeholder="请输入服务名称" />
                    </el-form-item>
                    <el-form-item label="联系人姓名" prop="contactName">
                      <el-input v-model="formData.contactName" placeholder="请输入联系人姓名" />
                    </el-form-item>
                    <el-form-item label="联系方式" prop="contactPhone">
                      <el-input v-model="formData.contactPhone" placeholder="请输入联系方式" />
                    </el-form-item>
      </el-form>
              <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" :disabled="formLoading">确 定</el-button>
        <el-button @click="dialogVisible = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import * as ManufacturerApi from '@/api/server/manufacturer';
      export default {
    name: "ManufacturerForm",
    components: {
                    },
    data() {
      return {
        // 弹出层标题
        dialogTitle: "",
        // 是否显示弹出层
        dialogVisible: false,
        // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
        formLoading: false,
        // 表单参数
        formData: {
                            id: undefined,
                            manufacturerName: undefined,
                            serviceName: undefined,
                            contactName: undefined,
                            contactPhone: undefined,
        },
        // 表单校验
        formRules: {
                        manufacturerName: [{ required: true, message: '厂商名称不能为空', trigger: 'blur' }],
                        serviceName: [{ required: true, message: '服务名称不能为空', trigger: 'blur' }],
                        contactName: [{ required: true, message: '联系人姓名不能为空', trigger: 'blur' }],
                        contactPhone: [{ required: true, message: '联系方式不能为空', trigger: 'blur' }],
        },
                        };
    },
    methods: {
      /** 打开弹窗 */
     async open(id) {
        this.dialogVisible = true;
        this.reset();
        // 修改时，设置数据
        if (id) {
          this.formLoading = true;
          try {
            const res = await ManufacturerApi.getManufacturer(id);
            this.formData = res.data;
            this.title = "修改技术运维单位";
          } finally {
            this.formLoading = false;
          }
        }
        this.title = "新增技术运维单位";
              },
      /** 提交按钮 */
      async submitForm() {
        // 校验主表
        await this.$refs["formRef"].validate();
                  this.formLoading = true;
        try {
          const data = this.formData;
                  // 修改的提交
          if (data.id) {
            await ManufacturerApi.updateManufacturer(data);
            this.$modal.msgSuccess("修改成功");
            this.dialogVisible = false;
            this.$emit('success');
            return;
          }
          // 添加的提交
          await ManufacturerApi.createManufacturer(data);
          this.$modal.msgSuccess("新增成功");
          this.dialogVisible = false;
          this.$emit('success');
        } finally {
          this.formLoading = false;
        }
      },
                      /** 表单重置 */
      reset() {
        this.formData = {
                            id: undefined,
                            manufacturerName: undefined,
                            serviceName: undefined,
                            contactName: undefined,
                            contactPhone: undefined,
        };
        this.resetForm("formRef");
      }
    }
  };
</script>
